﻿using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Input;

namespace ManipulationTracker
{
    partial class MainPage
    {
        bool ignoreCheckBoxChanges;

        public MainPage()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            // TODO: Confirm that this is the right way to exit an app
            Application.Current.Exit();
        }

        void OnManipulationModeCheckBoxChecked(object sender, RoutedEventArgs args)
        {
            if (ignoreCheckBoxChanges)
                return;

            ManipulationModeCheckBox checkBox = sender as ManipulationModeCheckBox;
            ManipulationModes manipulationModes = checkBox.ManipulationModes;

            if (checkBox.IsChecked.Value)
            {
                if (manipulationModes == ManipulationModes.None)
                    touchDisplay.ManipulationMode = manipulationModes;
                else
                    touchDisplay.ManipulationMode |= checkBox.ManipulationModes;
            }
            else
            {
                touchDisplay.ManipulationMode &= ~checkBox.ManipulationModes;
            }

            ignoreCheckBoxChanges = true;

            foreach (UIElement child in (checkBox.Parent as Panel).Children)
                if (child is ManipulationModeCheckBox)
                {
                    checkBox = child as ManipulationModeCheckBox;

                    if (checkBox.ManipulationModes == ManipulationModes.None)
                        checkBox.IsChecked = touchDisplay.ManipulationMode == ManipulationModes.None;
                    else
                        checkBox.IsChecked = (touchDisplay.ManipulationMode & checkBox.ManipulationModes) == checkBox.ManipulationModes;
                }

            ignoreCheckBoxChanges = false;
        }
    }
}
